declare enum EEventType {
    REGULAR = "REGULAR",
    WARNING = "WARNING",
    INFO = "INFO",
    ERROR = "ERROR"
}

interface IEvent {
    type: EEventType;
    data: any;
    label?: string;
    userInfo?: any;
}

interface IDebugger {
    appId: string;
    isInitializeFired: boolean;
    initialize: (appId: string) => void;
    log: (event: IEvent) => void;
}

declare const remoteDebugger: IDebugger;

export default remoteDebugger;
export { IEvent };
